require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PPC_ATOMIC_H_)) {
    eval 'sub _ASM_PPC_ATOMIC_H_ () {1;}' unless defined(&_ASM_PPC_ATOMIC_H_);
    if(defined(&__KERNEL__)) {
	eval 'sub ATOMIC_INIT {
	    my($i) = @_;
    	    eval q({ ($i) });
	}' unless defined(&ATOMIC_INIT);
	eval 'sub atomic_read {
	    my($v) = @_;
    	    eval q((($v)-> &counter));
	}' unless defined(&atomic_read);
	eval 'sub atomic_set {
	    my($v,$i) = @_;
    	    eval q(((($v)-> &counter) = ($i)));
	}' unless defined(&atomic_set);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub SMP_ISYNC () {"\\n\\tisync";}' unless defined(&SMP_ISYNC);
	} else {
	    eval 'sub SMP_ISYNC () {1;}' unless defined(&SMP_ISYNC);
	}
	if(defined(&CONFIG_IBM405_ERR77)) {
	    eval 'sub PPC405_ERR77 {
	        my($ra,$rb) = @_;
    		eval q(\\"dcbt \\" $ra \\",\\" $rb \\";\\");
	    }' unless defined(&PPC405_ERR77);
	} else {
	    eval 'sub PPC405_ERR77 {
	        my($ra,$rb) = @_;
    		eval q();
	    }' unless defined(&PPC405_ERR77);
	}
	eval 'sub atomic_add {
	    my($a,$v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_add);
	eval 'sub atomic_add_return {
	    my($a,$v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_add_return);
	eval 'sub atomic_sub {
	    my($a,$v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_sub);
	eval 'sub atomic_sub_return {
	    my($a,$v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_sub_return);
	eval 'sub atomic_inc {
	    my($v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_inc);
	eval 'sub atomic_inc_return {
	    my($v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_inc_return);
	eval 'sub atomic_dec {
	    my($v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_dec);
	eval 'sub atomic_dec_return {
	    my($v) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&atomic_dec_return);
	eval 'sub atomic_sub_and_test {
	    my($a, $v) = @_;
    	    eval q(( &atomic_sub_return(($a), ($v)) == 0));
	}' unless defined(&atomic_sub_and_test);
	eval 'sub atomic_dec_and_test {
	    my($v) = @_;
    	    eval q(( &atomic_dec_return(($v)) == 0));
	}' unless defined(&atomic_dec_and_test);
	eval 'sub smp_mb__before_atomic_dec () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_atomic_dec);
	eval 'sub smp_mb__after_atomic_dec () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_atomic_dec);
	eval 'sub smp_mb__before_atomic_inc () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__before_atomic_inc);
	eval 'sub smp_mb__after_atomic_inc () {
	    eval q( &smp_mb());
	}' unless defined(&smp_mb__after_atomic_inc);
    }
}
1;
