require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PPC_KERNEL_MPC10X_H)) {
    eval 'sub __PPC_KERNEL_MPC10X_H () {1;}' unless defined(&__PPC_KERNEL_MPC10X_H);
    require 'linux/pci_ids.ph';
    require 'asm/pci-bridge.ph';
    eval 'sub MPC10X_BRIDGE_106 () {(( &PCI_DEVICE_ID_MOTOROLA_MPC106 << 16) |  &PCI_VENDOR_ID_MOTOROLA);}' unless defined(&MPC10X_BRIDGE_106);
    eval 'sub MPC10X_BRIDGE_8240 () {((0x3 << 16) |  &PCI_VENDOR_ID_MOTOROLA);}' unless defined(&MPC10X_BRIDGE_8240);
    eval 'sub MPC10X_BRIDGE_107 () {((0x4 << 16) |  &PCI_VENDOR_ID_MOTOROLA);}' unless defined(&MPC10X_BRIDGE_107);
    eval 'sub MPC10X_BRIDGE_8245 () {((0x6 << 16) |  &PCI_VENDOR_ID_MOTOROLA);}' unless defined(&MPC10X_BRIDGE_8245);
    eval 'sub MPC10X_MEM_MAP_A () {1;}' unless defined(&MPC10X_MEM_MAP_A);
    eval 'sub MPC10X_MEM_MAP_B () {2;}' unless defined(&MPC10X_MEM_MAP_B);
    eval 'sub MPC10X_MAPA_CNFG_ADDR () {0x80000cf8;}' unless defined(&MPC10X_MAPA_CNFG_ADDR);
    eval 'sub MPC10X_MAPA_CNFG_DATA () {0x80000cfc;}' unless defined(&MPC10X_MAPA_CNFG_DATA);
    eval 'sub MPC10X_MAPA_ISA_IO_BASE () {0x80000000;}' unless defined(&MPC10X_MAPA_ISA_IO_BASE);
    eval 'sub MPC10X_MAPA_ISA_MEM_BASE () {0xc0000000;}' unless defined(&MPC10X_MAPA_ISA_MEM_BASE);
    eval 'sub MPC10X_MAPA_DRAM_OFFSET () {0x80000000;}' unless defined(&MPC10X_MAPA_DRAM_OFFSET);
    eval 'sub MPC10X_MAPA_PCI_IO_START () {0x;}' unless defined(&MPC10X_MAPA_PCI_IO_START);
    eval 'sub MPC10X_MAPA_PCI_IO_END () {(0x800000 - 1);}' unless defined(&MPC10X_MAPA_PCI_IO_END);
    eval 'sub MPC10X_MAPA_PCI_MEM_START () {0x;}' unless defined(&MPC10X_MAPA_PCI_MEM_START);
    eval 'sub MPC10X_MAPA_PCI_MEM_END () {(0x20000000 - 1);}' unless defined(&MPC10X_MAPA_PCI_MEM_END);
    eval 'sub MPC10X_MAPA_PCI_MEM_OFFSET () {( &MPC10X_MAPA_ISA_MEM_BASE -  &MPC10X_MAPA_PCI_MEM_START);}' unless defined(&MPC10X_MAPA_PCI_MEM_OFFSET);
    eval 'sub MPC10X_MAPB_CNFG_ADDR () {0xfec00000;}' unless defined(&MPC10X_MAPB_CNFG_ADDR);
    eval 'sub MPC10X_MAPB_CNFG_DATA () {0xfee00000;}' unless defined(&MPC10X_MAPB_CNFG_DATA);
    eval 'sub MPC10X_MAPB_ISA_IO_BASE () {0xfe000000;}' unless defined(&MPC10X_MAPB_ISA_IO_BASE);
    eval 'sub MPC10X_MAPB_ISA_MEM_BASE () {0x80000000;}' unless defined(&MPC10X_MAPB_ISA_MEM_BASE);
    eval 'sub MPC10X_MAPB_DRAM_OFFSET () {0x;}' unless defined(&MPC10X_MAPB_DRAM_OFFSET);
    eval 'sub MPC10X_MAPB_PCI_IO_START () {0x;}' unless defined(&MPC10X_MAPB_PCI_IO_START);
    eval 'sub MPC10X_MAPB_PCI_IO_END () {(0xc00000 - 1);}' unless defined(&MPC10X_MAPB_PCI_IO_END);
    eval 'sub MPC10X_MAPB_PCI_MEM_START () {0x80000000;}' unless defined(&MPC10X_MAPB_PCI_MEM_START);
    eval 'sub MPC10X_MAPB_PCI_MEM_END () {(0xc0000000 - 1);}' unless defined(&MPC10X_MAPB_PCI_MEM_END);
    eval 'sub MPC10X_MAPB_PCI_MEM_OFFSET () {( &MPC10X_MAPB_ISA_MEM_BASE -  &MPC10X_MAPB_PCI_MEM_START);}' unless defined(&MPC10X_MAPB_PCI_MEM_OFFSET);
    eval 'sub MPC10X_SETUP_HOSE {
        my($hose, $map) = @_;
	    eval q({ ($hose)-> &pci_mem_offset =  &MPC10X_MAP$map &_PCI_MEM_OFFSET; ($hose)-> ($io_space->{start}) =  &MPC10X_MAP$map &_PCI_IO_START; ($hose)-> ($io_space->{end}) =  &MPC10X_MAP$map &_PCI_IO_END; ($hose)-> ($mem_space->{start}) =  &MPC10X_MAP$map &_PCI_MEM_START; ($hose)-> ($mem_space->{end}) =  &MPC10X_MAP$map &_PCI_MEM_END; ($hose)-> &io_base_virt = ( &void *) &MPC10X_MAP$map &_ISA_IO_BASE; });
    }' unless defined(&MPC10X_SETUP_HOSE);
    eval 'sub MPC10X_CFG_PIR_REG () {0x9;}' unless defined(&MPC10X_CFG_PIR_REG);
    eval 'sub MPC10X_CFG_PIR_HOST_BRIDGE () {0x;}' unless defined(&MPC10X_CFG_PIR_HOST_BRIDGE);
    eval 'sub MPC10X_CFG_PIR_AGENT () {0x1;}' unless defined(&MPC10X_CFG_PIR_AGENT);
    eval 'sub MPC10X_CFG_EUMBBAR () {0x78;}' unless defined(&MPC10X_CFG_EUMBBAR);
    eval 'sub MPC10X_CFG_PICR1_REG () {0xa8;}' unless defined(&MPC10X_CFG_PICR1_REG);
    eval 'sub MPC10X_CFG_PICR1_ADDR_MAP_MASK () {0x10000;}' unless defined(&MPC10X_CFG_PICR1_ADDR_MAP_MASK);
    eval 'sub MPC10X_CFG_PICR1_ADDR_MAP_A () {0x10000;}' unless defined(&MPC10X_CFG_PICR1_ADDR_MAP_A);
    eval 'sub MPC10X_CFG_PICR1_ADDR_MAP_B () {0x;}' unless defined(&MPC10X_CFG_PICR1_ADDR_MAP_B);
    eval 'sub MPC10X_CFG_PICR1_ST_GATH_EN () {0x40;}' unless defined(&MPC10X_CFG_PICR1_ST_GATH_EN);
    eval 'sub MPC10X_CFG_MAPB_OPTIONS_REG () {0xe0;}' unless defined(&MPC10X_CFG_MAPB_OPTIONS_REG);
    eval 'sub MPC10X_CFG_MAPB_OPTIONS_CFAE () {0x80;}' unless defined(&MPC10X_CFG_MAPB_OPTIONS_CFAE);
    eval 'sub MPC10X_CFG_MAPB_OPTIONS_PFAE () {0x40;}' unless defined(&MPC10X_CFG_MAPB_OPTIONS_PFAE);
    eval 'sub MPC10X_CFG_MAPB_OPTIONS_DR () {0x20;}' unless defined(&MPC10X_CFG_MAPB_OPTIONS_DR);
    eval 'sub MPC10X_CFG_MAPB_OPTIONS_PCICH () {0x80;}' unless defined(&MPC10X_CFG_MAPB_OPTIONS_PCICH);
    eval 'sub MPC10X_CFG_MAPB_OPTIONS_PROCCH () {0x40;}' unless defined(&MPC10X_CFG_MAPB_OPTIONS_PROCCH);
    eval 'sub MPC10X_MCTLR_MEM_START_1 () {0x80;}' unless defined(&MPC10X_MCTLR_MEM_START_1);
    eval 'sub MPC10X_MCTLR_MEM_START_2 () {0x84;}' unless defined(&MPC10X_MCTLR_MEM_START_2);
    eval 'sub MPC10X_MCTLR_EXT_MEM_START_1 () {0x88;}' unless defined(&MPC10X_MCTLR_EXT_MEM_START_1);
    eval 'sub MPC10X_MCTLR_EXT_MEM_START_2 () {0x8c;}' unless defined(&MPC10X_MCTLR_EXT_MEM_START_2);
    eval 'sub MPC10X_MCTLR_MEM_END_1 () {0x90;}' unless defined(&MPC10X_MCTLR_MEM_END_1);
    eval 'sub MPC10X_MCTLR_MEM_END_2 () {0x94;}' unless defined(&MPC10X_MCTLR_MEM_END_2);
    eval 'sub MPC10X_MCTLR_EXT_MEM_END_1 () {0x98;}' unless defined(&MPC10X_MCTLR_EXT_MEM_END_1);
    eval 'sub MPC10X_MCTLR_EXT_MEM_END_2 () {0x9c;}' unless defined(&MPC10X_MCTLR_EXT_MEM_END_2);
    eval 'sub MPC10X_MCTLR_MEM_BANK_ENABLES () {0xa0;}' unless defined(&MPC10X_MCTLR_MEM_BANK_ENABLES);
    eval 'sub MPC10X_EUMB_SIZE () {0x100000;}' unless defined(&MPC10X_EUMB_SIZE);
    eval 'sub MPC10X_EUMB_MU_OFFSET () {0x;}' unless defined(&MPC10X_EUMB_MU_OFFSET);
    eval 'sub MPC10X_EUMB_MU_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_MU_SIZE);
    eval 'sub MPC10X_EUMB_DMA_OFFSET () {0x1000;}' unless defined(&MPC10X_EUMB_DMA_OFFSET);
    eval 'sub MPC10X_EUMB_DMA_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_DMA_SIZE);
    eval 'sub MPC10X_EUMB_ATU_OFFSET () {0x2000;}' unless defined(&MPC10X_EUMB_ATU_OFFSET);
    eval 'sub MPC10X_EUMB_ATU_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_ATU_SIZE);
    eval 'sub MPC10X_EUMB_I2C_OFFSET () {0x3000;}' unless defined(&MPC10X_EUMB_I2C_OFFSET);
    eval 'sub MPC10X_EUMB_I2C_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_I2C_SIZE);
    eval 'sub MPC10X_EUMB_DUART_OFFSET () {0x4000;}' unless defined(&MPC10X_EUMB_DUART_OFFSET);
    eval 'sub MPC10X_EUMB_DUART_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_DUART_SIZE);
    eval 'sub MPC10X_EUMB_EPIC_OFFSET () {0x40000;}' unless defined(&MPC10X_EUMB_EPIC_OFFSET);
    eval 'sub MPC10X_EUMB_EPIC_SIZE () {0x30000;}' unless defined(&MPC10X_EUMB_EPIC_SIZE);
    eval 'sub MPC10X_EUMB_PM_OFFSET () {0xfe000;}' unless defined(&MPC10X_EUMB_PM_OFFSET);
    eval 'sub MPC10X_EUMB_PM_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_PM_SIZE);
    eval 'sub MPC10X_EUMB_WP_OFFSET () {0xff000;}' unless defined(&MPC10X_EUMB_WP_OFFSET);
    eval 'sub MPC10X_EUMB_WP_SIZE () {0x1000;}' unless defined(&MPC10X_EUMB_WP_SIZE);
    eval 'sub MPC10X_MAPA_EUMB_BASE () {( &ioremap_base -  &MPC10X_EUMB_SIZE);}' unless defined(&MPC10X_MAPA_EUMB_BASE);
    eval 'sub MPC10X_MAPB_EUMB_BASE () { &MPC10X_MAPA_EUMB_BASE;}' unless defined(&MPC10X_MAPB_EUMB_BASE);
}
1;
