require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&__CONFIG_8xx_DEFS)) {
	eval 'sub __CONFIG_8xx_DEFS () {1;}' unless defined(&__CONFIG_8xx_DEFS);
	require 'linux/config.ph';
	if(defined(&CONFIG_8xx)) {
	    if(defined(&CONFIG_MBX)) {
		require 'platforms/mbx.ph';
	    }
	    if(defined(&CONFIG_FADS)) {
		require 'platforms/fads.ph';
	    }
	    if(defined(&CONFIG_RPXLITE)) {
		require 'platforms/rpxlite.ph';
	    }
	    if(defined(&CONFIG_BSEIP)) {
		require 'platforms/bseip.ph';
	    }
	    if(defined(&CONFIG_RPXCLASSIC)) {
		require 'platforms/rpxclassic.ph';
	    }
	    if(defined(&CONFIG_DBOX2)) {
		require 'platforms/dbox2.ph';
	    }
	    if(defined( &CONFIG_TQM8xxL)) {
		require 'platforms/tqm8xx.ph';
	    }
	    if(defined( &CONFIG_SPD823TS)) {
		require 'platforms/spd8xx.ph';
	    }
	    if(defined( &CONFIG_IVMS8) || defined( &CONFIG_IVML24)) {
		require 'platforms/ivms8.ph';
	    }
	    if(defined( &CONFIG_PCI)) {
		if(!defined( &_IO_BASE)) {
		    eval 'sub _IO_BASE () { &PCI_ISA_IO_ADDR;}' unless defined(&_IO_BASE);
		}
		if(!defined( &_ISA_MEM_BASE)) {
		    eval 'sub _ISA_MEM_BASE () { &PCI_ISA_MEM_ADDR;}' unless defined(&_ISA_MEM_BASE);
		}
		if(!defined( &PCI_DRAM_OFFSET)) {
		    eval 'sub PCI_DRAM_OFFSET () {0;}' unless defined(&PCI_DRAM_OFFSET);
		}
	    } else {
		if(!defined( &_IO_BASE)) {
		    eval 'sub _IO_BASE () {0;}' unless defined(&_IO_BASE);
		}
		if(!defined( &_ISA_MEM_BASE)) {
		    eval 'sub _ISA_MEM_BASE () {0;}' unless defined(&_ISA_MEM_BASE);
		}
		if(!defined( &PCI_DRAM_OFFSET)) {
		    eval 'sub PCI_DRAM_OFFSET () {0;}' unless defined(&PCI_DRAM_OFFSET);
		}
	    }
	    unless(defined(&__ASSEMBLY__)) {
		eval 'sub request_8xxirq () { &request_irq;}' unless defined(&request_8xxirq);
	    }
	}
    }
}
1;
