require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&__OCP_H__)) {
	eval 'sub __OCP_H__ () {1;}' unless defined(&__OCP_H__);
	require 'linux/init.ph';
	require 'linux/list.ph';
	require 'linux/config.ph';
	require 'linux/devfs_fs_kernel.ph';
	require 'asm/mmu.ph';
	require 'asm/ocp_ids.ph';
	require 'asm/rwsem.ph';
	require 'asm/semaphore.ph';
	if(defined( &CONFIG_IBM_OCP)) {
	    require 'platforms/ibm_ocp.ph';
	}
	if(defined( &CONFIG_MPC_OCP)) {
	    require 'asm/mpc_ocp.ph';
	}
	eval 'sub OCP_MAX_IRQS () {7;}' unless defined(&OCP_MAX_IRQS);
	eval 'sub MAX_EMACS () {4;}' unless defined(&MAX_EMACS);
	eval 'sub OCP_IRQ_NA () {-1;}' unless defined(&OCP_IRQ_NA);
	eval 'sub OCP_IRQ_MUL () {-2;}' unless defined(&OCP_IRQ_MUL);
	eval 'sub OCP_NULL_TYPE () {-1;}' unless defined(&OCP_NULL_TYPE);
	eval 'sub OCP_CPM_NA () {0;}' unless defined(&OCP_CPM_NA);
	eval 'sub OCP_PADDR_NA () {0;}' unless defined(&OCP_PADDR_NA);
	eval 'sub OCP_ANY_ID () {(~0);}' unless defined(&OCP_ANY_ID);
	eval 'sub OCP_ANY_INDEX () {-1;}' unless defined(&OCP_ANY_INDEX);
	eval 'sub ocp_set_drvdata {
	    my($pdev,$data) = @_;
    	    eval q({  ($pdev->{drvdata}) = $data; });
	}' unless defined(&ocp_set_drvdata);
	if(defined ( &CONFIG_PM)) {
	    eval 'sub ocp_force_power_on {
	        my($odev) = @_;
    		eval q({  &mtdcr( &DCRN_CPMFR,  &mfdcr( &DCRN_CPMFR) & ~ ($odev->{def}->{pm})); });
	    }' unless defined(&ocp_force_power_on);
	} else {
	    eval 'sub ocp_force_power_off {
	        my($x) = @_;
    		eval q(( &void)($x));
	    }' unless defined(&ocp_force_power_off);
	    eval 'sub ocp_force_power_on {
	        my($x) = @_;
    		eval q(( &void)($x));
	    }' unless defined(&ocp_force_power_on);
	}
    }
}
1;
