require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PPC_PCI_H)) {
    eval 'sub __PPC_PCI_H () {1;}' unless defined(&__PPC_PCI_H);
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	require 'linux/slab.ph';
	require 'linux/string.ph';
	require 'asm/scatterlist.ph';
	require 'asm/io.ph';
	eval 'sub IOBASE_BRIDGE_NUMBER () {0;}' unless defined(&IOBASE_BRIDGE_NUMBER);
	eval 'sub IOBASE_MEMORY () {1;}' unless defined(&IOBASE_MEMORY);
	eval 'sub IOBASE_IO () {2;}' unless defined(&IOBASE_IO);
	eval 'sub IOBASE_ISA_IO () {3;}' unless defined(&IOBASE_ISA_IO);
	eval 'sub IOBASE_ISA_MEM () {4;}' unless defined(&IOBASE_ISA_MEM);
	eval 'sub pcibios_assign_all_busses () {
	    eval q(( &pci_assign_all_busses));
	}' unless defined(&pcibios_assign_all_busses);
	eval 'sub pcibios_scan_all_fns () {
	    eval q(0);
	}' unless defined(&pcibios_scan_all_fns);
	eval 'sub PCIBIOS_MIN_IO () {0x1000;}' unless defined(&PCIBIOS_MIN_IO);
	eval 'sub PCIBIOS_MIN_MEM () {0x10000000;}' unless defined(&PCIBIOS_MIN_MEM);
	eval 'sub PCI_DMA_BUS_IS_PHYS () {(1);}' unless defined(&PCI_DMA_BUS_IS_PHYS);
	eval 'sub pci_unmap_single {
	    my($hwdev,$dma_addr,$size,$direction) = @_;
    	    eval q({  &if ($direction ==  &PCI_DMA_NONE)  &BUG(); }  &define  &DECLARE_PCI_UNMAP_ADDR( &ADDR_NAME)  &define  &DECLARE_PCI_UNMAP_LEN( &LEN_NAME)  &define  &pci_unmap_addr( &PTR,  &ADDR_NAME) (0)  &define  &pci_unmap_addr_set( &PTR,  &ADDR_NAME,  &VAL)  &do { }  &while (0)  &define  &pci_unmap_len( &PTR,  &LEN_NAME) (0)  &define  &pci_unmap_len_set( &PTR,  &LEN_NAME,  &VAL)  &do { }  &while (0)  &dma_addr_t  &pci_map_page(\'struct pci_dev\' *$hwdev, \'struct page\' * &page, my $offset, \'size_t\' $size, \'int\' $direction) {  &BUG_ON($direction ==  &PCI_DMA_NONE);  &consistent_sync_page( &page,  $offset, $size, $direction); ( &page -  &mem_map) *  &PAGE_SIZE +  &PCI_DRAM_OFFSET +  $offset; });
	}' unless defined(&pci_unmap_single);
	eval 'sub pci_unmap_page {
	    my($hwdev,$dma_address,$size,$direction) = @_;
    	    eval q({  &if ($direction ==  &PCI_DMA_NONE)  &BUG(); } \'int\'  &pci_map_sg(\'struct pci_dev\' *$hwdev, \'struct scatterlist\' * &sg, \'int\'  &nents, \'int\' $direction) { \'int\'  &i;  &if ($direction ==  &PCI_DMA_NONE)  &BUG();  &for ( &i = 0;  &i <  &nents;  &i++) {  &if ( ($sg[&i]->{address})  &&  ($sg[&i]->{page}))  &BUG();  &else  &if (! ($sg[&i]->{address})  && ! ($sg[&i]->{page}))  &BUG();  &if ( ($sg[&i]->{address})) {  &consistent_sync( ($sg[&i]->{address}),  ($sg[&i]->{length}), $direction);  ($sg[&i]->{dma_address}) =  &virt_to_bus( ($sg[&i]->{address})); }  &else {  &consistent_sync_page( ($sg[&i]->{page}),  ($sg[&i]->{offset}),  ($sg[&i]->{length}), $direction);  ($sg[&i]->{dma_address}) =  &page_to_bus( ($sg[&i]->{page})) +  ($sg[&i]->{offset}); }  ($sg[&i]->{dma_length}) =  ($sg[&i]->{length}); }  &nents; });
	}' unless defined(&pci_unmap_page);
	eval 'sub pci_dac_dma_supported {
	    my($pci_dev, $mask) = @_;
    	    eval q((0));
	}' unless defined(&pci_dac_dma_supported);
	eval 'sub pci_dac_page_to_dma {
	    my($pdev,$page,$offset,$direction) = @_;
    	    eval q({ ( &dma64_addr_t)  &page_to_bus($page) + $offset; });
	}' unless defined(&pci_dac_page_to_dma);
	eval 'sub pci_dac_dma_to_page {
	    my($pdev,$dma_addr) = @_;
    	    eval q({  &mem_map + ($dma_addr >>  &PAGE_SHIFT); });
	}' unless defined(&pci_dac_dma_to_page);
	eval 'sub pci_dac_dma_to_offset {
	    my($pdev,$dma_addr) = @_;
    	    eval q({ ($dma_addr & ~ &PAGE_MASK); });
	}' unless defined(&pci_dac_dma_to_offset);
	eval 'sub pci_dac_dma_sync_single {
	    my($pdev,$dma_addr,$len,$direction) = @_;
    	    eval q({ } \'int\'  &pci_controller_num(\'struct pci_dev\' *$pdev); \'int\'  &pci_mmap_page_range(\'struct pci_dev\' *$pdev, \'struct vm_area_struct\' * &vma,  &enum  &pci_mmap_state  &mmap_state, \'int\'  &write_combine);  &define  &HAVE_PCI_MMAP 1 &endif  &endif );
	}' unless defined(&pci_dac_dma_sync_single);
1;
