require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&__ASM_SMPLOCK_H__)) {
	eval 'sub __ASM_SMPLOCK_H__ () {1;}' unless defined(&__ASM_SMPLOCK_H__);
	require 'linux/interrupt.ph';
	require 'linux/spinlock.ph';
	eval 'sub kernel_locked () {
	    eval q( &spin_is_locked( &kernel_flag));
	}' unless defined(&kernel_locked);
	eval 'sub release_kernel_lock {
	    my($task, $cpu) = @_;
    	    eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_unlock( &kernel_flag);  &release_irqlock($cpu);  &__sti(); }  &while (0));
	}' unless defined(&release_kernel_lock);
	eval 'sub reacquire_kernel_lock {
	    my($task) = @_;
    	    eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_lock( &kernel_flag); }  &while (0));
	}' unless defined(&reacquire_kernel_lock);
	eval 'sub unlock_kernel {
	    my($void) = @_;
    	    eval q({  &if (-- ($current->{lock_depth}) < 0)  &spin_unlock( &kernel_flag); });
	}' unless defined(&unlock_kernel);
    }
}
1;
