require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_BITS_SYSCALLS_H)) {
    eval 'sub _BITS_SYSCALLS_H () {1;}' unless defined(&_BITS_SYSCALLS_H);
    unless(defined(&_SYSCALL_H)) {
	die("Never use <bits/syscalls.h> directly; include <sys/syscall.h> instead.");
    }
    require 'bits/sysnum.ph';
    eval 'sub __STRINGIFY {
        my($s) = @_;
	    eval q( &__STRINGIFY2 ($s));
    }' unless defined(&__STRINGIFY);
    eval 'sub __STRINGIFY2 {
        my($s) = @_;
	    eval q($s);
    }' unless defined(&__STRINGIFY2);
    undef(&JUMPTARGET) if defined(&JUMPTARGET);
    if(defined(&__PIC__)) {
	eval 'sub __MAKE_SYSCALL () { &__STRINGIFY( &__uClibc_syscall@ &plt);}' unless defined(&__MAKE_SYSCALL);
    } else {
	eval 'sub __MAKE_SYSCALL () { &__STRINGIFY( &__uClibc_syscall);}' unless defined(&__MAKE_SYSCALL);
    }
    eval 'sub unified_syscall_body {
        my($name) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&unified_syscall_body);
    undef(&_syscall0) if defined(&_syscall0);
    eval 'sub _syscall0 {
        my($type,$name) = @_;
	    eval q($type $name( &void);  &unified_syscall_body($name));
    }' unless defined(&_syscall0);
    undef(&_syscall1) if defined(&_syscall1);
    eval 'sub _syscall1 {
        my($type,$name,$type1,$arg1) = @_;
	    eval q($type $name($type1 $arg1);  &unified_syscall_body($name));
    }' unless defined(&_syscall1);
    undef(&_syscall2) if defined(&_syscall2);
    eval 'sub _syscall2 {
        my($type,$name,$type1,$arg1,$type2,$arg2) = @_;
	    eval q($type $name($type1 $arg1, $type2 $arg2);  &unified_syscall_body($name));
    }' unless defined(&_syscall2);
    undef(&_syscall3) if defined(&_syscall3);
    eval 'sub _syscall3 {
        my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3) = @_;
	    eval q($type $name($type1 $arg1, $type2 $arg2, $type3 $arg3);  &unified_syscall_body($name));
    }' unless defined(&_syscall3);
    undef(&_syscall4) if defined(&_syscall4);
    eval 'sub _syscall4 {
        my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4) = @_;
	    eval q($type $name($type1 $arg1, $type2 $arg2, $type3 $arg3, $type4 $arg4);  &unified_syscall_body($name));
    }' unless defined(&_syscall4);
    undef(&_syscall5) if defined(&_syscall5);
    eval 'sub _syscall5 {
        my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4,$type5,$arg5) = @_;
	    eval q($type $name($type1 $arg1, $type2 $arg2, $type3 $arg3, $type4 $arg4, $type5 $arg5);  &unified_syscall_body($name));
    }' unless defined(&_syscall5);
    undef(&_syscall6) if defined(&_syscall6);
    eval 'sub _syscall6 {
        my($type,$name,$type1,$arg1,$type2,$arg2,$type3,$arg3,$type4,$arg4,$type5,$arg5,$type6,$arg6) = @_;
	    eval q($type $name($type1 $arg1, $type2 $arg2, $type3 $arg3, $type4 $arg4, $type5 $arg5, $type6 $arg6);  &unified_syscall_body($name));
    }' unless defined(&_syscall6);
}
1;
