require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PPC_BYTEORDER_H)) {
    eval 'sub _PPC_BYTEORDER_H () {1;}' unless defined(&_PPC_BYTEORDER_H);
    require 'asm/types.ph';
    if(defined(&__GNUC__)) {
	if(defined(&__KERNEL__)) {
	    eval 'sub ld_le16 {
	        my($addr) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&ld_le16);
	    eval 'sub st_le16 {
	        my($addr,$val) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&st_le16);
	    eval 'sub ld_le32 {
	        my($addr) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&ld_le32);
	    eval 'sub st_le32 {
	        my($addr,$val) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&st_le32);
	    eval 'sub ld_le64 {
	        my($addr) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&ld_le64);
	    eval 'sub st_le64 {
	        my($addr,$val) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&st_le64);
	    eval 'sub ___arch__swab16 {
	        my($value) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&___arch__swab16);
	    eval 'sub ___arch__swab32 {
	        my($value) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&___arch__swab32);
	    eval 'sub __arch__swab32 {
	        my($x) = @_;
    		eval q( &___arch__swab32($x));
	    }' unless defined(&__arch__swab32);
	    eval 'sub __arch__swab16 {
	        my($x) = @_;
    		eval q( &___arch__swab16($x));
	    }' unless defined(&__arch__swab16);
	    eval 'sub __arch__swab16p {
	        my($addr) = @_;
    		eval q( &ld_le16($addr));
	    }' unless defined(&__arch__swab16p);
	    eval 'sub __arch__swab32p {
	        my($addr) = @_;
    		eval q( &ld_le32($addr));
	    }' unless defined(&__arch__swab32p);
	    eval 'sub __arch__swab64p {
	        my($addr) = @_;
    		eval q( &ld_le64($addr));
	    }' unless defined(&__arch__swab64p);
	    eval 'sub __arch__swab16s {
	        my($addr) = @_;
    		eval q( &st_le16($addr,*$addr));
	    }' unless defined(&__arch__swab16s);
	    eval 'sub __arch__swab32s {
	        my($addr) = @_;
    		eval q( &st_le32($addr,*$addr));
	    }' unless defined(&__arch__swab32s);
	    eval 'sub __arch__swab64s {
	        my($addr) = @_;
    		eval q( &st_le64($addr,*$addr));
	    }' unless defined(&__arch__swab64s);
	}
	if(!defined( &__STRICT_ANSI__) || defined( &__KERNEL__)) {
	    eval 'sub __BYTEORDER_HAS_U64__ () {1;}' unless defined(&__BYTEORDER_HAS_U64__);
	    eval 'sub __SWAB_64_THRU_32__ () {1;}' unless defined(&__SWAB_64_THRU_32__);
	}
    }
    require 'linux/byteorder/big_endian.ph';
}
1;
