require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_HIGHMEM_H)) {
    eval 'sub _ASM_HIGHMEM_H () {1;}' unless defined(&_ASM_HIGHMEM_H);
    if(defined(&__KERNEL__)) {
	require 'linux/init.ph';
	require 'linux/interrupt.ph';
	require 'asm/kmap_types.ph';
	require 'asm/pgtable.ph';
	eval 'sub HIGHMEM_DEBUG () {1;}' unless defined(&HIGHMEM_DEBUG);
	eval 'sub PKMAP_BASE () { &CONFIG_HIGHMEM_START;}' unless defined(&PKMAP_BASE);
	eval 'sub LAST_PKMAP () { &PTRS_PER_PTE;}' unless defined(&LAST_PKMAP);
	eval 'sub LAST_PKMAP_MASK () {( &LAST_PKMAP-1);}' unless defined(&LAST_PKMAP_MASK);
	eval 'sub PKMAP_NR {
	    my($virt) = @_;
    	    eval q((($virt- &PKMAP_BASE) >>  &PAGE_SHIFT));
	}' unless defined(&PKMAP_NR);
	eval 'sub PKMAP_ADDR {
	    my($nr) = @_;
    	    eval q(( &PKMAP_BASE + (($nr) <<  &PAGE_SHIFT)));
	}' unless defined(&PKMAP_ADDR);
	eval 'sub KMAP_FIX_BEGIN () {( &PKMAP_BASE + 0x400000);}' unless defined(&KMAP_FIX_BEGIN);
	eval 'sub kmap {
	    my($page) = @_;
    	    eval q( &__kmap($page, 0));
	}' unless defined(&kmap);
	eval 'sub kmap_nonblock {
	    my($page) = @_;
    	    eval q( &__kmap($page, 1));
	}' unless defined(&kmap_nonblock);
	eval 'sub void {
	    eval q(* &__kmap(\'struct page\' * &page, \'int\'  &nonblock) {  &if ( &in_interrupt())  &BUG();  &if ( &page <  &highmem_start_page)  &page_address( &page);  &kmap_high( &page,  &nonblock); });
	}' unless defined(&void);
	eval 'sub kunmap {
	    my($page) = @_;
    	    eval q({  &if ( &in_interrupt())  &BUG();  &if ($page <  &highmem_start_page) ;  &kunmap_high($page); });
	}' unless defined(&kunmap);
	if((defined(&HIGHMEM_DEBUG) ? &HIGHMEM_DEBUG : 0)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub kunmap_atomic {
	    my($kvaddr,$type) = @_;
    	    eval q({ });
	}' unless defined(&kunmap_atomic);
    }
}
1;
