require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_HW_IRQ_H)) {
	eval 'sub _PPC_HW_IRQ_H () {1;}' unless defined(&_PPC_HW_IRQ_H);
	eval 'sub __save_flags {
	    my($flags) = @_;
    	    eval q( &__save_flags_ptr($flags));
	}' unless defined(&__save_flags);
	eval 'sub __save_and_cli {
	    my($flags) = @_;
    	    eval q(({ &__save_flags($flags); &__cli();}));
	}' unless defined(&__save_and_cli);
	eval 'sub __save_and_sti {
	    my($flags) = @_;
    	    eval q(({ &__save_flags($flags); &__sti();}));
	}' unless defined(&__save_and_sti);
	eval 'sub mask_irq {
	    my($irq) = @_;
    	    eval q(({ &if ( ($irq_desc[$irq]->{handler})  &&  ($irq_desc[$irq]->{handler}->{disable}))  ($irq_desc[$irq]->{handler}->{disable})($irq);}));
	}' unless defined(&mask_irq);
	eval 'sub unmask_irq {
	    my($irq) = @_;
    	    eval q(({ &if ( ($irq_desc[$irq]->{handler})  &&  ($irq_desc[$irq]->{handler}->{enable}))  ($irq_desc[$irq]->{handler}->{enable})($irq);}));
	}' unless defined(&unmask_irq);
	eval 'sub ack_irq {
	    my($irq) = @_;
    	    eval q(({ &if ( ($irq_desc[$irq]->{handler})  &&  ($irq_desc[$irq]->{handler}->{ack}))  ($irq_desc[$irq]->{handler}->{ack})($irq);}));
	}' unless defined(&ack_irq);
    }
}
1;
