require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&__ASM_IBM4XX_H__)) {
	eval 'sub __ASM_IBM4XX_H__ () {1;}' unless defined(&__ASM_IBM4XX_H__);
	require 'linux/config.ph';
	require 'asm/types.ph';
	if(defined(&CONFIG_4xx)) {
	    unless(defined(&__ASSEMBLY__)) {
		eval 'sub stringify {
		    my($s) = @_;
    		    eval q( &tostring($s));
		}' unless defined(&stringify);
		eval 'sub tostring {
		    my($s) = @_;
    		    eval q($s);
		}' unless defined(&tostring);
		eval 'sub mfdcr_or_dflt {
		    my($rn,$default_rval) = @_;
    		    eval q(({\'unsigned int rval\';  &if ($rn == 0)  &rval = $default_rval;  &else  &asm  &volatile(\\"mfdcr %0,\\"  &stringify($rn) : \\"=r\\" ( &rval));  &rval;}));
		}' unless defined(&mfdcr_or_dflt);
		eval 'sub mfdcri {
		    my($base, $reg) = @_;
    		    eval q(({  &mtdcr($base &_CFGADDR, $base &_$reg);  &mfdcr($base &_CFGDATA); }));
		}' unless defined(&mfdcri);
		eval 'sub mtdcri {
		    my($base, $reg, $data) = @_;
    		    eval q( &do {  &mtdcr($base &_CFGADDR, $base &_$reg);  &mtdcr($base &_CFGDATA, $data); }  &while (0));
		}' unless defined(&mtdcri);
	    }
	}
	if(defined(&CONFIG_40x)) {
	    if(defined( &CONFIG_CPCI405)) {
		require 'platforms/cpci405.ph';
	    }
	    if(defined( &CONFIG_EP405)) {
		require 'platforms/ep405.ph';
	    }
	    if(defined( &CONFIG_OAK)) {
		require 'platforms/oak.ph';
	    }
	    if(defined( &CONFIG_REDWOOD_5)) {
		require 'platforms/redwood5.ph';
	    }
	    if(defined( &CONFIG_REDWOOD_6)) {
		require 'platforms/redwood6.ph';
	    }
	    if(defined( &CONFIG_WALNUT)) {
		require 'platforms/walnut.ph';
	    }
	    unless(defined(&PPC4xx_MACHINE_NAME)) {
		eval 'sub PPC4xx_MACHINE_NAME () {"Unidentified 4xx class";}' unless defined(&PPC4xx_MACHINE_NAME);
	    }
	    unless(defined(&_IO_BASE)) {
		eval 'sub _IO_BASE () {0xe8000000;}' unless defined(&_IO_BASE);
		eval 'sub _ISA_MEM_BASE () {0;}' unless defined(&_ISA_MEM_BASE);
		eval 'sub PCI_DRAM_OFFSET () {0;}' unless defined(&PCI_DRAM_OFFSET);
	    }
	}
 elsif((defined(&CONFIG_44x) ? &CONFIG_44x : 0)) {
	    if(defined( &CONFIG_EBONY)) {
		require 'platforms/ebony.ph';
	    }
	    if(defined( &CONFIG_OCOTEA)) {
		require 'platforms/ocotea.ph';
	    }
	}
	unless(defined(&__ASSEMBLY__)) {
	    if(defined( &EMAC_NUMS)  && (defined(&EMAC_NUMS) ? &EMAC_NUMS : 0) > 0) {
	    }
	}
    }
}
1;
