require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&KL_PANGEA_REV)) {
    sub KL_PANGEA_REV () {	0x100;}
}
unless(defined(&KEYLARGO_MBCR)) {
    sub KEYLARGO_MBCR () {	0x34;}
}
unless(defined(&KEYLARGO_FCR0)) {
    sub KEYLARGO_FCR0 () {	0x38;}
}
unless(defined(&KEYLARGO_FCR1)) {
    sub KEYLARGO_FCR1 () {	0x3c;}
}
unless(defined(&KEYLARGO_FCR2)) {
    sub KEYLARGO_FCR2 () {	0x40;}
}
unless(defined(&KEYLARGO_FCR3)) {
    sub KEYLARGO_FCR3 () {	0x44;}
}
unless(defined(&KEYLARGO_FCR4)) {
    sub KEYLARGO_FCR4 () {	0x48;}
}
unless(defined(&KEYLARGO_FCR5)) {
    sub KEYLARGO_FCR5 () {	0x4c;}
}
unless(defined(&KEYLARGO_GPIO_LEVELS0)) {
    sub KEYLARGO_GPIO_LEVELS0 () {	0x50;}
}
unless(defined(&KEYLARGO_GPIO_LEVELS1)) {
    sub KEYLARGO_GPIO_LEVELS1 () {	0x54;}
}
unless(defined(&KEYLARGO_GPIO_EXTINT_0)) {
    sub KEYLARGO_GPIO_EXTINT_0 () {	0x58;}
}
unless(defined(&KEYLARGO_GPIO_EXTINT_CNT)) {
    sub KEYLARGO_GPIO_EXTINT_CNT () {	18;}
}
unless(defined(&KEYLARGO_GPIO_0)) {
    sub KEYLARGO_GPIO_0 () {	0x6a;}
}
unless(defined(&KEYLARGO_GPIO_CNT)) {
    sub KEYLARGO_GPIO_CNT () {	17;}
}
unless(defined(&KEYLARGO_GPIO_EXTINT_DUAL_EDGE)) {
    sub KEYLARGO_GPIO_EXTINT_DUAL_EDGE () {	0x80;}
}
unless(defined(&KEYLARGO_GPIO_OUTPUT_ENABLE)) {
    sub KEYLARGO_GPIO_OUTPUT_ENABLE () {	0x4;}
}
unless(defined(&KEYLARGO_GPIO_OUTOUT_DATA)) {
    sub KEYLARGO_GPIO_OUTOUT_DATA () {	0x1;}
}
unless(defined(&KEYLARGO_GPIO_INPUT_DATA)) {
    sub KEYLARGO_GPIO_INPUT_DATA () {	0x2;}
}
unless(defined(&KL_GPIO_MODEM_RESET)) {
    sub KL_GPIO_MODEM_RESET () {	( &KEYLARGO_GPIO_0+0x3);}
}
unless(defined(&KL_GPIO_MODEM_POWER)) {
    sub KL_GPIO_MODEM_POWER () {	( &KEYLARGO_GPIO_0+0x2);}
}
unless(defined(&KL_GPIO_SOUND_POWER)) {
    sub KL_GPIO_SOUND_POWER () {	( &KEYLARGO_GPIO_0+0x5);}
}
unless(defined(&KL_GPIO_FW_CABLE_POWER)) {
    sub KL_GPIO_FW_CABLE_POWER () {	( &KEYLARGO_GPIO_0+0x9);}
}
unless(defined(&KL_GPIO_TB_ENABLE)) {
    sub KL_GPIO_TB_ENABLE () {	( &KEYLARGO_GPIO_0+0x9);}
}
unless(defined(&KL_GPIO_ETH_PHY_RESET)) {
    sub KL_GPIO_ETH_PHY_RESET () {	( &KEYLARGO_GPIO_0+0x10);}
}
unless(defined(&KL_GPIO_EXTINT_CPU1)) {
    sub KL_GPIO_EXTINT_CPU1 () {	( &KEYLARGO_GPIO_0+0xa);}
}
unless(defined(&KL_GPIO_EXTINT_CPU1_ASSERT)) {
    sub KL_GPIO_EXTINT_CPU1_ASSERT () {	0x4;}
}
unless(defined(&KL_GPIO_EXTINT_CPU1_RELEASE)) {
    sub KL_GPIO_EXTINT_CPU1_RELEASE () {	0x38;}
}
unless(defined(&KL_GPIO_RESET_CPU0)) {
    sub KL_GPIO_RESET_CPU0 () {	( &KEYLARGO_GPIO_EXTINT_0+0x3);}
}
unless(defined(&KL_GPIO_RESET_CPU1)) {
    sub KL_GPIO_RESET_CPU1 () {	( &KEYLARGO_GPIO_EXTINT_0+0x4);}
}
unless(defined(&KL_GPIO_RESET_CPU2)) {
    sub KL_GPIO_RESET_CPU2 () {	( &KEYLARGO_GPIO_EXTINT_0+0xf);}
}
unless(defined(&KL_GPIO_RESET_CPU3)) {
    sub KL_GPIO_RESET_CPU3 () {	( &KEYLARGO_GPIO_EXTINT_0+0x10);}
}
unless(defined(&KL_GPIO_PMU_MESSAGE_IRQ)) {
    sub KL_GPIO_PMU_MESSAGE_IRQ () {	( &KEYLARGO_GPIO_EXTINT_0+0x9);}
}
unless(defined(&KL_GPIO_PMU_MESSAGE_BIT)) {
    sub KL_GPIO_PMU_MESSAGE_BIT () {	 &KEYLARGO_GPIO_INPUT_DATA;}
}
unless(defined(&KL_GPIO_MEDIABAY_IRQ)) {
    sub KL_GPIO_MEDIABAY_IRQ () {	( &KEYLARGO_GPIO_EXTINT_0+0xe);}
}
unless(defined(&KL_GPIO_AIRPORT_0)) {
    sub KL_GPIO_AIRPORT_0 () {	( &KEYLARGO_GPIO_EXTINT_0+0xa);}
}
unless(defined(&KL_GPIO_AIRPORT_1)) {
    sub KL_GPIO_AIRPORT_1 () {	( &KEYLARGO_GPIO_EXTINT_0+0xd);}
}
unless(defined(&KL_GPIO_AIRPORT_2)) {
    sub KL_GPIO_AIRPORT_2 () {	( &KEYLARGO_GPIO_0+0xd);}
}
unless(defined(&KL_GPIO_AIRPORT_3)) {
    sub KL_GPIO_AIRPORT_3 () {	( &KEYLARGO_GPIO_0+0xe);}
}
unless(defined(&KL_GPIO_AIRPORT_4)) {
    sub KL_GPIO_AIRPORT_4 () {	( &KEYLARGO_GPIO_0+0xf);}
}
unless(defined(&KL_MBCR_MB0_PCI_ENABLE)) {
    sub KL_MBCR_MB0_PCI_ENABLE () {	0x800;}
}
unless(defined(&KL_MBCR_MB0_IDE_ENABLE)) {
    sub KL_MBCR_MB0_IDE_ENABLE () {	0x1000;}
}
unless(defined(&KL_MBCR_MB0_FLOPPY_ENABLE)) {
    sub KL_MBCR_MB0_FLOPPY_ENABLE () {	0x2000;}
}
unless(defined(&KL_MBCR_MB0_SOUND_ENABLE)) {
    sub KL_MBCR_MB0_SOUND_ENABLE () {	0x4000;}
}
unless(defined(&KL_MBCR_MB0_DEV_MASK)) {
    sub KL_MBCR_MB0_DEV_MASK () {	0x7800;}
}
unless(defined(&KL_MBCR_MB0_DEV_POWER)) {
    sub KL_MBCR_MB0_DEV_POWER () {	0x400;}
}
unless(defined(&KL_MBCR_MB0_DEV_RESET)) {
    sub KL_MBCR_MB0_DEV_RESET () {	0x200;}
}
unless(defined(&KL_MBCR_MB0_ENABLE)) {
    sub KL_MBCR_MB0_ENABLE () {	0x100;}
}
unless(defined(&KL_MBCR_MB1_PCI_ENABLE)) {
    sub KL_MBCR_MB1_PCI_ENABLE () {	0x8000000;}
}
unless(defined(&KL_MBCR_MB1_IDE_ENABLE)) {
    sub KL_MBCR_MB1_IDE_ENABLE () {	0x10000000;}
}
unless(defined(&KL_MBCR_MB1_FLOPPY_ENABLE)) {
    sub KL_MBCR_MB1_FLOPPY_ENABLE () {	0x20000000;}
}
unless(defined(&KL_MBCR_MB1_SOUND_ENABLE)) {
    sub KL_MBCR_MB1_SOUND_ENABLE () {	0x40000000;}
}
unless(defined(&KL_MBCR_MB1_DEV_MASK)) {
    sub KL_MBCR_MB1_DEV_MASK () {	0x78000000;}
}
unless(defined(&KL_MBCR_MB1_DEV_POWER)) {
    sub KL_MBCR_MB1_DEV_POWER () {	0x4000000;}
}
unless(defined(&KL_MBCR_MB1_DEV_RESET)) {
    sub KL_MBCR_MB1_DEV_RESET () {	0x2000000;}
}
unless(defined(&KL_MBCR_MB1_ENABLE)) {
    sub KL_MBCR_MB1_ENABLE () {	0x1000000;}
}
unless(defined(&KL0_SCC_B_INTF_ENABLE)) {
    sub KL0_SCC_B_INTF_ENABLE () {	0x1;}
}
unless(defined(&KL0_SCC_A_INTF_ENABLE)) {
    sub KL0_SCC_A_INTF_ENABLE () {	0x2;}
}
unless(defined(&KL0_SCC_SLOWPCLK)) {
    sub KL0_SCC_SLOWPCLK () {	0x4;}
}
unless(defined(&KL0_SCC_RESET)) {
    sub KL0_SCC_RESET () {	0x8;}
}
unless(defined(&KL0_SCCA_ENABLE)) {
    sub KL0_SCCA_ENABLE () {	0x10;}
}
unless(defined(&KL0_SCCB_ENABLE)) {
    sub KL0_SCCB_ENABLE () {	0x20;}
}
unless(defined(&KL0_SCC_CELL_ENABLE)) {
    sub KL0_SCC_CELL_ENABLE () {	0x40;}
}
unless(defined(&KL0_IRDA_HIGH_BAND)) {
    sub KL0_IRDA_HIGH_BAND () {	0x100;}
}
unless(defined(&KL0_IRDA_SOURCE2_SEL)) {
    sub KL0_IRDA_SOURCE2_SEL () {	0x200;}
}
unless(defined(&KL0_IRDA_SOURCE1_SEL)) {
    sub KL0_IRDA_SOURCE1_SEL () {	0x400;}
}
unless(defined(&KL0_PG_USB0_PMI_ENABLE)) {
    sub KL0_PG_USB0_PMI_ENABLE () {	0x400;}
}
unless(defined(&KL0_IRDA_RESET)) {
    sub KL0_IRDA_RESET () {	0x800;}
}
unless(defined(&KL0_PG_USB0_REF_SUSPEND_SEL)) {
    sub KL0_PG_USB0_REF_SUSPEND_SEL () {	0x800;}
}
unless(defined(&KL0_IRDA_DEFAULT1)) {
    sub KL0_IRDA_DEFAULT1 () {	0x1000;}
}
unless(defined(&KL0_PG_USB0_REF_SUSPEND)) {
    sub KL0_PG_USB0_REF_SUSPEND () {	0x1000;}
}
unless(defined(&KL0_IRDA_DEFAULT0)) {
    sub KL0_IRDA_DEFAULT0 () {	0x2000;}
}
unless(defined(&KL0_PG_USB0_PAD_SUSPEND)) {
    sub KL0_PG_USB0_PAD_SUSPEND () {	0x2000;}
}
unless(defined(&KL0_IRDA_FAST_CONNECT)) {
    sub KL0_IRDA_FAST_CONNECT () {	0x4000;}
}
unless(defined(&KL0_PG_USB1_PMI_ENABLE)) {
    sub KL0_PG_USB1_PMI_ENABLE () {	0x4000;}
}
unless(defined(&KL0_IRDA_ENABLE)) {
    sub KL0_IRDA_ENABLE () {	0x8000;}
}
unless(defined(&KL0_PG_USB1_REF_SUSPEND_SEL)) {
    sub KL0_PG_USB1_REF_SUSPEND_SEL () {	0x8000;}
}
unless(defined(&KL0_IRDA_CLK32_ENABLE)) {
    sub KL0_IRDA_CLK32_ENABLE () {	0x10000;}
}
unless(defined(&KL0_PG_USB1_REF_SUSPEND)) {
    sub KL0_PG_USB1_REF_SUSPEND () {	0x10000;}
}
unless(defined(&KL0_IRDA_CLK19_ENABLE)) {
    sub KL0_IRDA_CLK19_ENABLE () {	0x20000;}
}
unless(defined(&KL0_PG_USB1_PAD_SUSPEND)) {
    sub KL0_PG_USB1_PAD_SUSPEND () {	0x20000;}
}
unless(defined(&KL0_USB0_PAD_SUSPEND0)) {
    sub KL0_USB0_PAD_SUSPEND0 () {	0x40000;}
}
unless(defined(&KL0_USB0_PAD_SUSPEND1)) {
    sub KL0_USB0_PAD_SUSPEND1 () {	0x80000;}
}
unless(defined(&KL0_USB0_CELL_ENABLE)) {
    sub KL0_USB0_CELL_ENABLE () {	0x100000;}
}
unless(defined(&KL0_USB1_PAD_SUSPEND0)) {
    sub KL0_USB1_PAD_SUSPEND0 () {	0x400000;}
}
unless(defined(&KL0_USB1_PAD_SUSPEND1)) {
    sub KL0_USB1_PAD_SUSPEND1 () {	0x800000;}
}
unless(defined(&KL0_USB1_CELL_ENABLE)) {
    sub KL0_USB1_CELL_ENABLE () {	0x1000000;}
}
unless(defined(&KL0_USB_REF_SUSPEND)) {
    sub KL0_USB_REF_SUSPEND () {	0x10000000;}
}
unless(defined(&KL0_SERIAL_ENABLE)) {
    sub KL0_SERIAL_ENABLE () {	( &KL0_SCC_B_INTF_ENABLE |  &KL0_SCC_SLOWPCLK |  &KL0_SCC_CELL_ENABLE |  &KL0_SCCA_ENABLE);}
}
unless(defined(&KL1_USB2_PMI_ENABLE)) {
    sub KL1_USB2_PMI_ENABLE () {	0x1;}
}
unless(defined(&KL1_AUDIO_SEL_22MCLK)) {
    sub KL1_AUDIO_SEL_22MCLK () {	0x2;}
}
unless(defined(&KL1_USB2_REF_SUSPEND_SEL)) {
    sub KL1_USB2_REF_SUSPEND_SEL () {	0x2;}
}
unless(defined(&KL1_USB2_REF_SUSPEND)) {
    sub KL1_USB2_REF_SUSPEND () {	0x4;}
}
unless(defined(&KL1_AUDIO_CLK_ENABLE_BIT)) {
    sub KL1_AUDIO_CLK_ENABLE_BIT () {	0x8;}
}
unless(defined(&KL1_USB2_PAD_SUSPEND_SEL)) {
    sub KL1_USB2_PAD_SUSPEND_SEL () {	0x8;}
}
unless(defined(&KL1_USB2_PAD_SUSPEND0)) {
    sub KL1_USB2_PAD_SUSPEND0 () {	0x10;}
}
unless(defined(&KL1_AUDIO_CLK_OUT_ENABLE)) {
    sub KL1_AUDIO_CLK_OUT_ENABLE () {	0x20;}
}
unless(defined(&KL1_USB2_PAD_SUSPEND1)) {
    sub KL1_USB2_PAD_SUSPEND1 () {	0x20;}
}
unless(defined(&KL1_AUDIO_CELL_ENABLE)) {
    sub KL1_AUDIO_CELL_ENABLE () {	0x40;}
}
unless(defined(&KL1_USB2_CELL_ENABLE)) {
    sub KL1_USB2_CELL_ENABLE () {	0x40;}
}
unless(defined(&KL1_AUDIO_CHOOSE)) {
    sub KL1_AUDIO_CHOOSE () {	0x80;}
}
unless(defined(&KL1_I2S0_CHOOSE)) {
    sub KL1_I2S0_CHOOSE () {	0x200;}
}
unless(defined(&KL1_I2S0_CELL_ENABLE)) {
    sub KL1_I2S0_CELL_ENABLE () {	0x400;}
}
unless(defined(&KL1_I2S0_CLK_ENABLE_BIT)) {
    sub KL1_I2S0_CLK_ENABLE_BIT () {	0x1000;}
}
unless(defined(&KL1_I2S0_ENABLE)) {
    sub KL1_I2S0_ENABLE () {	0x2000;}
}
unless(defined(&KL1_I2S1_CELL_ENABLE)) {
    sub KL1_I2S1_CELL_ENABLE () {	0x20000;}
}
unless(defined(&KL1_I2S1_CLK_ENABLE_BIT)) {
    sub KL1_I2S1_CLK_ENABLE_BIT () {	0x80000;}
}
unless(defined(&KL1_I2S1_ENABLE)) {
    sub KL1_I2S1_ENABLE () {	0x100000;}
}
unless(defined(&KL1_EIDE0_ENABLE)) {
    sub KL1_EIDE0_ENABLE () {	0x800000;}
}
unless(defined(&KL1_EIDE0_RESET_N)) {
    sub KL1_EIDE0_RESET_N () {	0x1000000;}
}
unless(defined(&KL1_EIDE1_ENABLE)) {
    sub KL1_EIDE1_ENABLE () {	0x4000000;}
}
unless(defined(&KL1_EIDE1_RESET_N)) {
    sub KL1_EIDE1_RESET_N () {	0x8000000;}
}
unless(defined(&KL1_UIDE_ENABLE)) {
    sub KL1_UIDE_ENABLE () {	0x20000000;}
}
unless(defined(&KL1_UIDE_RESET_N)) {
    sub KL1_UIDE_RESET_N () {	0x40000000;}
}
unless(defined(&KL2_IOBUS_ENABLE)) {
    sub KL2_IOBUS_ENABLE () {	0x2;}
}
unless(defined(&KL2_SLEEP_STATE_BIT)) {
    sub KL2_SLEEP_STATE_BIT () {	0x100;}
}
unless(defined(&KL2_PG_STOP_ALL_CLOCKS)) {
    sub KL2_PG_STOP_ALL_CLOCKS () {	0x100;}
}
unless(defined(&KL2_MPIC_ENABLE)) {
    sub KL2_MPIC_ENABLE () {	0x20000;}
}
unless(defined(&KL2_CARDSLOT_RESET)) {
    sub KL2_CARDSLOT_RESET () {	0x40000;}
}
unless(defined(&KL2_ALT_DATA_OUT)) {
    sub KL2_ALT_DATA_OUT () {	0x2000000;}
}
unless(defined(&KL2_MEM_IS_BIG)) {
    sub KL2_MEM_IS_BIG () {	0x4000000;}
}
unless(defined(&KL2_CARDSEL_16)) {
    sub KL2_CARDSEL_16 () {	0x8000000;}
}
unless(defined(&KL3_SHUTDOWN_PLL_TOTAL)) {
    sub KL3_SHUTDOWN_PLL_TOTAL () {	0x1;}
}
unless(defined(&KL3_SHUTDOWN_PLLKW6)) {
    sub KL3_SHUTDOWN_PLLKW6 () {	0x2;}
}
unless(defined(&KL3_IT_SHUTDOWN_PLL3)) {
    sub KL3_IT_SHUTDOWN_PLL3 () {	0x2;}
}
unless(defined(&KL3_SHUTDOWN_PLLKW4)) {
    sub KL3_SHUTDOWN_PLLKW4 () {	0x4;}
}
unless(defined(&KL3_IT_SHUTDOWN_PLL2)) {
    sub KL3_IT_SHUTDOWN_PLL2 () {	0x4;}
}
unless(defined(&KL3_SHUTDOWN_PLLKW35)) {
    sub KL3_SHUTDOWN_PLLKW35 () {	0x8;}
}
unless(defined(&KL3_IT_SHUTDOWN_PLL1)) {
    sub KL3_IT_SHUTDOWN_PLL1 () {	0x8;}
}
unless(defined(&KL3_SHUTDOWN_PLLKW12)) {
    sub KL3_SHUTDOWN_PLLKW12 () {	0x10;}
}
unless(defined(&KL3_IT_ENABLE_PLL3_SHUTDOWN)) {
    sub KL3_IT_ENABLE_PLL3_SHUTDOWN () {	0x10;}
}
unless(defined(&KL3_PLL_RESET)) {
    sub KL3_PLL_RESET () {	0x20;}
}
unless(defined(&KL3_IT_ENABLE_PLL2_SHUTDOWN)) {
    sub KL3_IT_ENABLE_PLL2_SHUTDOWN () {	0x20;}
}
unless(defined(&KL3_IT_ENABLE_PLL1_SHUTDOWN)) {
    sub KL3_IT_ENABLE_PLL1_SHUTDOWN () {	0x10;}
}
unless(defined(&KL3_SHUTDOWN_PLL2X)) {
    sub KL3_SHUTDOWN_PLL2X () {	0x80;}
}
unless(defined(&KL3_CLK66_ENABLE)) {
    sub KL3_CLK66_ENABLE () {	0x100;}
}
unless(defined(&KL3_CLK49_ENABLE)) {
    sub KL3_CLK49_ENABLE () {	0x200;}
}
unless(defined(&KL3_CLK45_ENABLE)) {
    sub KL3_CLK45_ENABLE () {	0x400;}
}
unless(defined(&KL3_CLK31_ENABLE)) {
    sub KL3_CLK31_ENABLE () {	0x800;}
}
unless(defined(&KL3_TIMER_CLK18_ENABLE)) {
    sub KL3_TIMER_CLK18_ENABLE () {	0x1000;}
}
unless(defined(&KL3_I2S1_CLK18_ENABLE)) {
    sub KL3_I2S1_CLK18_ENABLE () {	0x2000;}
}
unless(defined(&KL3_I2S0_CLK18_ENABLE)) {
    sub KL3_I2S0_CLK18_ENABLE () {	0x4000;}
}
unless(defined(&KL3_VIA_CLK16_ENABLE)) {
    sub KL3_VIA_CLK16_ENABLE () {	0x8000;}
}
unless(defined(&KL3_IT_VIA_CLK32_ENABLE)) {
    sub KL3_IT_VIA_CLK32_ENABLE () {	0x8000;}
}
unless(defined(&KL3_STOPPING33_ENABLED)) {
    sub KL3_STOPPING33_ENABLED () {	0x80000;}
}
unless(defined(&KL3_PG_PLL_ENABLE_TEST)) {
    sub KL3_PG_PLL_ENABLE_TEST () {	0x80000;}
}
unless(defined(&KL3_IT_PORT_WAKEUP_ENABLE)) {
    sub KL3_IT_PORT_WAKEUP_ENABLE {
	my($p) = @_;
	eval q((0x80000 << (($p)<<3)));
    }
}
unless(defined(&KL3_IT_PORT_RESUME_WAKE_EN)) {
    sub KL3_IT_PORT_RESUME_WAKE_EN {
	my($p) = @_;
	eval q((0x40000 << (($p)<<3)));
    }
}
unless(defined(&KL3_IT_PORT_CONNECT_WAKE_EN)) {
    sub KL3_IT_PORT_CONNECT_WAKE_EN {
	my($p) = @_;
	eval q((0x20000 << (($p)<<3)));
    }
}
unless(defined(&KL3_IT_PORT_DISCONNECT_WAKE_EN)) {
    sub KL3_IT_PORT_DISCONNECT_WAKE_EN {
	my($p) = @_;
	eval q((0x10000 << (($p)<<3)));
    }
}
unless(defined(&KL3_IT_PORT_RESUME_STAT)) {
    sub KL3_IT_PORT_RESUME_STAT {
	my($p) = @_;
	eval q((0x300000 << (($p)<<3)));
    }
}
unless(defined(&KL3_IT_PORT_CONNECT_STAT)) {
    sub KL3_IT_PORT_CONNECT_STAT {
	my($p) = @_;
	eval q((0x200000 << (($p)<<3)));
    }
}
unless(defined(&KL3_IT_PORT_DISCONNECT_STAT)) {
    sub KL3_IT_PORT_DISCONNECT_STAT {
	my($p) = @_;
	eval q((0x100000 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_WAKEUP_ENABLE)) {
    sub KL4_PORT_WAKEUP_ENABLE {
	my($p) = @_;
	eval q((0x8 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_RESUME_WAKE_EN)) {
    sub KL4_PORT_RESUME_WAKE_EN {
	my($p) = @_;
	eval q((0x4 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_CONNECT_WAKE_EN)) {
    sub KL4_PORT_CONNECT_WAKE_EN {
	my($p) = @_;
	eval q((0x2 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_DISCONNECT_WAKE_EN)) {
    sub KL4_PORT_DISCONNECT_WAKE_EN {
	my($p) = @_;
	eval q((0x1 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_RESUME_STAT)) {
    sub KL4_PORT_RESUME_STAT {
	my($p) = @_;
	eval q((0x40 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_CONNECT_STAT)) {
    sub KL4_PORT_CONNECT_STAT {
	my($p) = @_;
	eval q((0x20 << (($p)<<3)));
    }
}
unless(defined(&KL4_PORT_DISCONNECT_STAT)) {
    sub KL4_PORT_DISCONNECT_STAT {
	my($p) = @_;
	eval q((0x10 << (($p)<<3)));
    }
}
unless(defined(&KL5_VIA_USE_CLK31)) {
    sub KL5_VIA_USE_CLK31 () {	0x1;}
}
unless(defined(&KL5_SCC_USE_CLK31)) {
    sub KL5_SCC_USE_CLK31 () {	0x2;}
}
unless(defined(&KL5_PWM_CLK32_EN)) {
    sub KL5_PWM_CLK32_EN () {	0x4;}
}
unless(defined(&KL5_CLK3_68_EN)) {
    sub KL5_CLK3_68_EN () {	0x10;}
}
unless(defined(&KL5_CLK32_EN)) {
    sub KL5_CLK32_EN () {	0x20;}
}
1;
