require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_SPINLOCK_H)) {
    eval 'sub __ASM_SPINLOCK_H () {1;}' unless defined(&__ASM_SPINLOCK_H);
    require 'asm/system.ph';
    require 'asm/processor.ph';
    if(defined( &CONFIG_DEBUG_SPINLOCK)) {
	eval 'sub SPINLOCK_DEBUG () {1;}' unless defined(&SPINLOCK_DEBUG);
    } else {
	eval 'sub SPINLOCK_DEBUG () {0;}' unless defined(&SPINLOCK_DEBUG);
    }
    if((defined(&SPINLOCK_DEBUG) ? &SPINLOCK_DEBUG : 0)) {
    }
    if(defined(&__KERNEL__)) {
	if((defined(&SPINLOCK_DEBUG) ? &SPINLOCK_DEBUG : 0)) {
	    eval 'sub SPINLOCK_DEBUG_INIT () {, 0, 0;}' unless defined(&SPINLOCK_DEBUG_INIT);
	} else {
	    eval 'sub SPINLOCK_DEBUG_INIT () {1;}' unless defined(&SPINLOCK_DEBUG_INIT);
	}
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0 &SPINLOCK_DEBUG_INIT };}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q( &do { *($x) =  &SPIN_LOCK_UNLOCKED; }  &while(0));
	}' unless defined(&spin_lock_init);
	eval 'sub spin_is_locked {
	    my($x) = @_;
    	    eval q((($x)-> &lock != 0));
	}' unless defined(&spin_is_locked);
	eval 'sub spin_unlock_wait {
	    my($x) = @_;
    	    eval q( &do {  &barrier(); }  &while( &spin_is_locked($x)));
	}' unless defined(&spin_unlock_wait);
	if((defined(&SPINLOCK_DEBUG) ? &SPINLOCK_DEBUG : 0)) {
	    eval 'sub spin_lock {
	        my($lp) = @_;
    		eval q( &_spin_lock($lp));
	    }' unless defined(&spin_lock);
	    eval 'sub spin_unlock {
	        my($lp) = @_;
    		eval q( &_spin_unlock($lp));
	    }' unless defined(&spin_unlock);
	} else {
	    eval 'sub spin_lock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&spin_lock);
	    eval 'sub spin_unlock {
	        my($lock) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&spin_unlock);
	    eval 'sub spin_trylock {
	        my($lock) = @_;
    		eval q((! &test_and_set_bit(0,($lock))));
	    }' unless defined(&spin_trylock);
	}
	if((defined(&SPINLOCK_DEBUG) ? &SPINLOCK_DEBUG : 0)) {
	}
	if((defined(&SPINLOCK_DEBUG) ? &SPINLOCK_DEBUG : 0)) {
	    eval 'sub RWLOCK_DEBUG_INIT () {, 0;}' unless defined(&RWLOCK_DEBUG_INIT);
	} else {
	    eval 'sub RWLOCK_DEBUG_INIT () {1;}' unless defined(&RWLOCK_DEBUG_INIT);
	}
	eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0 &RWLOCK_DEBUG_INIT };}' unless defined(&RW_LOCK_UNLOCKED);
	eval 'sub rwlock_init {
	    my($lp) = @_;
    	    eval q( &do { *($lp) =  &RW_LOCK_UNLOCKED; }  &while(0));
	}' unless defined(&rwlock_init);
	if((defined(&SPINLOCK_DEBUG) ? &SPINLOCK_DEBUG : 0)) {
	    eval 'sub read_lock {
	        my($rw) = @_;
    		eval q( &_read_lock($rw));
	    }' unless defined(&read_lock);
	    eval 'sub write_lock {
	        my($rw) = @_;
    		eval q( &_write_lock($rw));
	    }' unless defined(&write_lock);
	    eval 'sub write_unlock {
	        my($rw) = @_;
    		eval q( &_write_unlock($rw));
	    }' unless defined(&write_unlock);
	    eval 'sub read_unlock {
	        my($rw) = @_;
    		eval q( &_read_unlock($rw));
	    }' unless defined(&read_unlock);
	} else {
	    eval 'sub read_lock {
	        my($rw) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&read_lock);
	    eval 'sub read_unlock {
	        my($rw) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&read_unlock);
	    eval 'sub write_lock {
	        my($rw) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&write_lock);
	    eval 'sub write_unlock {
	        my($rw) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&write_unlock);
	}
    }
}
1;
